# NOTE: also update this in debian/hda-platform.postinst
%define schema_version	20110120223420

Name:           hda-platform
Version: 6.1.5
Release:        1

Summary:        hda-platform is the Amahi web interface platform.

Group:          System Environment/Daemons
License:        GPL
Source:         %{name}-%{version}.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:      noarch

Requires: hdactl >= 4.1.0
Requires: ruby ruby-mysql ruby-libs ruby-devel eruby
Requires: ruby-irb ruby-bdb ruby-racc ruby-rdoc eruby-libs ruby-ri
Requires: rubygems >= 1.3.1
Requires: rubygem-actionmailer rubygem-actionpack rubygem-activerecord
Requires: rubygem-activeresource rubygem-activesupport
Requires: rubygem-gruff rubygem-hoe rubygem-gd2
Requires: rubygem-rails >= 2.3
Requires: httpd hddtemp patch mysql-server
Requires: hda-greyhole >= 0.7.5
Requires: tar unzip bzip2 wol
Requires: rubygem-passenger rubygem-passenger-native mod_passenger

%define debug_package %{nil}

%description
hda-platform is the Amahi web platform.

%prep
%setup -q

%build

%install
rm -rf $RPM_BUILD_ROOT

# platform server initialitation
mkdir -p $RPM_BUILD_ROOT/var/hda
(cd $RPM_BUILD_ROOT/var/hda/ && mkdir -p platform apps web-apps dbs drives shares domain-settings elevated)
mkdir -p $RPM_BUILD_ROOT/var/hda/platform/logs
mkdir -p $RPM_BUILD_ROOT/etc/httpd/conf.d
mkdir -p $RPM_BUILD_ROOT/var/hda/domain-settings/netlogon
mkdir -p $RPM_BUILD_ROOT/var/hda/domain-settings/profiles
mkdir -p $RPM_BUILD_ROOT/var/lib/samba/drivers
rsync -aC html $RPM_BUILD_ROOT/var/hda/platform/
mkdir -p $RPM_BUILD_ROOT%{_sbindir}
install -p hda-gems-install $RPM_BUILD_ROOT%{_sbindir}
install -p hda-diskmount $RPM_BUILD_ROOT%{_sbindir}
install -p hda-add-apache-sudoers $RPM_BUILD_ROOT%{_sbindir}

# pdc logon script
install -m 644 -p pdc/logon.bat $RPM_BUILD_ROOT/var/hda/domain-settings/netlogon

# needed for gruff
mkdir -p $RPM_BUILD_ROOT/usr/share/fonts/default/TrueType/
rsync -Ca fonts/ $RPM_BUILD_ROOT/usr/share/fonts/default/TrueType/

mkdir -p $RPM_BUILD_ROOT/usr/share/hda-platform
rsync -Ca webapps $RPM_BUILD_ROOT/usr/share/hda-platform/
install -m 755 -p hda-usermap $RPM_BUILD_ROOT/usr/share/hda-platform/
mkdir -p $RPM_BUILD_ROOT%{_bindir}
install -m 755 -p hda-refresh-shares $RPM_BUILD_ROOT%{_bindir}
install -m 755 -p hda-update-webapps $RPM_BUILD_ROOT%{_bindir}
install -m 755 -p hda-create-db-and-user $RPM_BUILD_ROOT%{_bindir}
install -m 755 -p amahi-download $RPM_BUILD_ROOT%{_bindir}
touch $RPM_BUILD_ROOT/var/hda/web-apps/htpasswd

%clean
rm -rf $RPM_BUILD_ROOT

%post

if [[ -e /var/cache/hdactl.cache ]]; then
	if grep -q yes /var/cache/hdactl.cache ; then
		# FIXME - ugh - this gem install was inserted in 2/10 and can be
		# removed once the installer and dependencies are all clear
		(hda-install-gem rails 2.3.4; \
		cd /var/hda/platform/html && rake db:migrate RAILS_ENV=production VERSION=%{schema_version}; \
		./script/install-servers; \
		touch /var/hda/platform/html/tmp/restart.txt || true ) >> /var/log/amahi-platform-migration.log 2>&1 
		(/bin/rm -rf /etc/httpd/conf.d/welcome.conf > /dev/null 2>&1) || true
	fi
fi

touch /var/hda/platform/html/log/production.log
touch /var/hda/platform/html/log/development.log

%preun

if [ "$1" = 0 ]; then
	# not an update, a complete uninstall
	true
else
	# an update
        (/sbin/service hdactl reload || true) &> /dev/null
        (/sbin/service httpd reload || true) &> /dev/null
	(/sbin/service smb reload || true) &> /dev/null
	(/sbin/service nmb reload || true) &> /dev/null
fi

%files
%defattr(-,root,root,-)
%attr(755, apache, apache) /var/hda/apps
%attr(755, apache, apache) /var/hda/web-apps
%attr(755, apache, apache) /var/hda/dbs
%attr(755, apache, apache) /var/hda/drives
%attr(755, apache, apache) /var/hda/shares
%attr(755, apache, apache) /var/hda/domain-settings
%attr(755, apache, apache) /var/hda/elevated
%attr(755, apache, apache) /var/hda/platform
%attr(644, apache, apache) /var/hda/platform/html/log/*
%attr(600, apache, apache) /var/hda/web-apps/htpasswd
%attr(775, apache, users) /var/hda/domain-settings/netlogon
%attr(644, root, root) /var/hda/domain-settings/netlogon/logon.bat
%attr(775, apache, users) /var/hda/domain-settings/profiles
%config(noreplace) /var/hda/platform/html/config/*.yml
/var/lib/samba/drivers
%{_sbindir}/*
%{_bindir}/*
/usr/share/fonts/default/TrueType/*
/usr/share/hda-platform/*


%changelog
* Sun Mar 11 2009 carlos puchol
- major upgrades to the platform
